/* For free support for VSIDE, please visit www.vsdsp-forum.com */

#include <vo_stdio.h>
#include <volink.h>     // Linker directives like DLLENTRY
#include <apploader.h>  // RunLibraryFunction etc
#include <consolestate.h>
#include <string.h>
#include <vo_fat.h>
#include <ctype.h>

char s[256];
VO_FILE *f;


void ListDevices() {
	int i;
	char s[80];
	printf("Currently installed system devices are:\n"); //Decorative listout of all devices
	for (i=0; i<26; i++) {
		if (vo_pdevices[i]) {
			DiskGeometry g = {0, 0};
			printf("- %c: ", 'A'+i);
			if (ioctl(vo_pdevices[i], IOCTL_GET_GEOMETRY, (void *)&g) != S_ERROR) {
				g.totalSectors >>= 1; /* Now in KiB */
				if (g.totalSectors < 10000) {
					printf("%4ldK", g.totalSectors);
				} else if (g.totalSectors /= 1024, g.totalSectors < 10000) {
					printf("%4ldM", g.totalSectors);
				} else {
					printf("%4ldG", g.totalSectors/1024);
				}
			} else {
				printf("      ");
			}
			printf(" %s", vo_pdevices[i]->Identify(vo_pdevices[i],0,0));
			if (vo_pdevices[i]->fs) {
				printf(", handled by %s",vo_pdevices[i]->fs->Identify(vo_pdevices[i]->fs,0,0));
			}
			printf(".\n");
			
		}
	}
}


ioresult main(char *parameters) {
  u_int16 i;
  char *p = parameters;
  int nParam = RunLibraryFunction("ParamSpl",ENTRY_MAIN,(u_int16)parameters);

  if (!nParam) {
    puts(currentDirectory);
    return S_OK;
  }

  for (i=0; i<nParam; i++) {
    if (!strcmp(p, "-h")) {
      printf("Usage: cd [-h] [dir1 [dir2 [...]]]\n"
	     "-h\tShow this help\n"
	     "Note: cd without parameters shows the current directory\n"
	     "      cd :: lists all available devices\n");
      goto finally;
    } else {
      char e = p[strlen(p)-1];
	
      if ((strstr(p,"/")) || (strstr(p,"\\"))) {
      toocomplex:
	printf("Please give only a single subdirectory name without slashes ('music') or a new disk ('D:') as a parameter to this version of CD.\n");
	return S_ERROR;
      }
	
      if ((p[0] == '.') && (strlen(currentDirectory) > 2)) { //.. 
	char *p = &currentDirectory[strlen(currentDirectory)-1];
	*p=0;
	while (p >= currentDirectory + 2) {
	  if (p[-1] == '/') {
	    p[0] = 0;
	  } else {
	    *p=0;
	    p--;
	  }
	}
      } else if (p[1]==':') {
	DEVICE *newDisk;
	if (strlen(p) != 2) goto toocomplex;
	p[0] = toupper(p[0]);
	if (!isalpha(p[0])) {
	  ListDevices();
	} else {
	  newDisk = vo_pdevices[p[0]-'A']; 
	  if (!newDisk) {
	    printf("Disk %s not found. ", p);
	  nodevice:
	    ListDevices();
	    return S_ERROR;
	  }
	  if (newDisk->Identify && (appFlags & APP_FLAG_ECHO)) {
	    printf("%s %s\n", p, newDisk->Identify(newDisk,NULL,0)); 
	  }
	  if (newDisk->fs != vo_filesystems[0]) {
	    printf("Filesystem of device %s is not FAT.\n");
	    return S_ERROR;
	  }
	  strcpy(currentDirectory,p);
	}
      } else {
	f = fopen(currentDirectory,"s");
	if (!f) {
	  printf("The current directory is not valid.");
	  return S_ERROR;
	} else {
	  sprintf(s,"%s%s/",&currentDirectory[2],p);
	  if (FatFindFirst(f,s,NULL,0) != S_OK) {
	    printf("Path not found\n");
	  } else {
	    sprintf(s,"%s%s/",currentDirectory,p);
	    strcpy(currentDirectory,s);
	  }
	  fclose(f);
	}
      }
    }
    p += strlen(p)+1;
  }

 finally:
  return S_OK;
}
