/* For free support for VSIDE, please visit www.vsdsp-forum.com */

/// \file liblist.c Print out a list of loaded libraries and free mem to stdout
/// \author Panu-Kristian Poiksalo, VLSI Solution Oy


#include <vo_stdio.h>
#include <volink.h>
#include <apploader.h>
#include <lcd.h>
#include <stdbuttons.h>
#include <string.h>
#include "memstore.h"
#include <ctype.h>

const char ixy[] = "IXY";


u_int16 LibNameCompare(u_int16 *lib, const char *name) {
	u_int16 *p = lib;
	u_int16 entries;
	u_int16 nSections;	
	entries = *p++;
	p += entries + 5;	
	nSections = *p++;
	p += nSections * 2 + 1;
	{
		char *s = (char*)p;
		while (1) {
			//printf("<%c%c>",*s,*name);
			if (*name == 0) return 1;
			if (*s == 0) return 1;
			if (toupper(*s) != toupper(*name)) return 0;
			s++; name++;
		}
	}
	
	//fprintf(of," %5di +%5dx +%5dy \n",sizes[0],sizes[1],sizes[2]);
}

void *FindLib(const char *name) {
	u_int16 i;
	for (i=0; i<MAX_LIB; i++) {
		if (loadedLib[i] && LibNameCompare(loadedLib[i],name)) return loadedLib[i];
	}
	return NULL;
}

int main(char *parameters) {
	u_int16 i;
	printf("%s:%p\n",parameters,FindLib(parameters));

	//fprintf(vo_stderr,"\n%d libs loaded:\n",loadedLibs);
	for (i=0; i<MAX_LIB; i++) {
		if (loadedLib[i]) {
			printf("%p:%d\n",loadedLib[i],LibNameCompare(loadedLib[i],parameters));
		}
	}
	//PrintFreeMem();
}
